package sun.security.provider;

import java.io.IOException;
import java.util.ArrayList;
import java.security.cert.X509Certificate;
import java.util.Set;
import java.security.Principal;
import javax.security.auth.PrivateCredentialPermission;
import java.security.AllPermission;
import java.security.Permissions;
import java.security.PermissionCollection;
import javax.security.auth.Subject;
import java.security.KeyStoreException;
import java.util.StringTokenizer;
import java.security.Permission;
import java.util.Iterator;
import java.lang.reflect.InvocationTargetException;
import java.security.UnresolvedPermission;
import java.security.CodeSource;
import java.util.Enumeration;
import java.io.InputStreamReader;
import java.security.cert.Certificate;
import java.io.File;
import sun.security.util.PropertyExpander;
import java.security.Security;
import java.io.BufferedInputStream;
import sun.security.util.PolicyUtil;
import java.net.MalformedURLException;
import java.security.KeyStore;
import java.net.URL;
import java.security.AccessController;
import java.security.PrivilegedAction;
import javax.security.auth.AuthPermission;
import java.util.Hashtable;
import java.util.Vector;
import sun.security.util.Debug;
import java.util.ResourceBundle;
import javax.security.auth.Policy;

@Deprecated
public class AuthPolicyFile extends Policy
{
    static final ResourceBundle rb;
    private static final Debug debug;
    private static final String AUTH_POLICY = "java.security.auth.policy";
    private static final String SECURITY_MANAGER = "java.security.manager";
    private static final String AUTH_POLICY_URL = "auth.policy.url.";
    private Vector<AuthPolicyFile.PolicyEntry> policyEntries;
    private Hashtable<Object, Object> aliasMapping;
    private boolean initialized;
    private boolean expandProperties;
    private boolean ignoreIdentityScope;
    private static final Class<?>[] PARAMS;
    
    public AuthPolicyFile() {
        this.initialized = false;
        this.expandProperties = true;
        this.ignoreIdentityScope = true;
        String s = System.getProperty("java.security.auth.policy");
        if (s == null) {
            s = System.getProperty("java.security.manager");
        }
        if (s != null) {
            this.init();
        }
    }
    
    private synchronized void init() {
        if (this.initialized) {
            return;
        }
        this.policyEntries = new Vector();
        this.aliasMapping = new Hashtable(11);
        this.initPolicyFile();
        this.initialized = true;
        return;
    }
    
    public synchronized void refresh() {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkPermission(new AuthPermission("refreshPolicy"));
        }
        this.initialized = false;
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                AuthPolicyFile.access$000(AuthPolicyFile.this);
                return null;
            }
        });
    }
    
    private KeyStore initKeyStore(URL context, String s, String type) {
        if (s != null) {
            try {
                URL url;
                try {
                    url = new URL(s);
                }
                catch (MalformedURLException ex) {
                    url = new URL(context, s);
                }
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("reading keystore" + url);
                }
                BufferedInputStream stream = new BufferedInputStream(PolicyUtil.getInputStream(url));
                KeyStore keyStore;
                if (type != null) {
                    keyStore = KeyStore.getInstance(type);
                }
                else {
                    keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
                }
                keyStore.load(stream, (char[])null);
                stream.close();
                return keyStore;
            }
            catch (Exception ex2) {
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("Debug info only. No keystore.");
                    ex2.printStackTrace();
                }
                return null;
            }
        }
        else {
            return null;
        }
    }
    
    private void initPolicyFile() {
        String property = Security.getProperty("policy.expandProperties");
        if (property != null) {
            this.expandProperties = property.equalsIgnoreCase("true");
        }
        String property2 = Security.getProperty("policy.ignoreIdentityScope");
        if (property2 != null) {
            this.ignoreIdentityScope = property2.equalsIgnoreCase("true");
        }
        String property3 = Security.getProperty("policy.allowSystemProperty");
        if (property3 != null && property3.equalsIgnoreCase("true")) {
            String value = System.getProperty("java.security.auth.policy");
            if (value != null) {
                boolean n = false;
                if (value.startsWith("=")) {
                    n = true;
                    value = value.substring(1);
                }
                try {
                    String expand = PropertyExpander.expand(value);
                    File o = new File(expand);
                    Object obj;
                    if (o.exists()) {
                        obj = new URL("file:" + o.getCanonicalPath());
                    }
                    else {
                        obj = new URL(expand);
                    }
                    if (AuthPolicyFile.debug != null) {
                        AuthPolicyFile.debug.println("reading " + obj);
                    }
                    this.init(obj);
                }
                catch (Exception obj2) {
                    if (AuthPolicyFile.debug != null) {
                        AuthPolicyFile.debug.println("caught exception: " + obj2);
                    }
                }
                if (!(n == 0)) {
                    if (AuthPolicyFile.debug != null) {
                        AuthPolicyFile.debug.println("overriding other policies!");
                    }
                    return;
                }
            }
        }
        String property4;
        for (int i = 1; (property4 = Security.getProperty("auth.policy.url." + i)) != null; ++i) {
            try {
                String replace = PropertyExpander.expand(property4).replace(File.separatorChar, '/');
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("reading " + replace);
                }
                this.init(new URL(replace));
            }
            catch (Exception obj3) {
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("Debug info only. Error reading policy " + obj3);
                    obj3.printStackTrace();
                }
            }
        }
    }
    
    private boolean checkForTrustedIdentity(Certificate certificate) {
        return false;
    }
    
    private void init(URL obj) {
        PolicyParser policyParser = new PolicyParser(this.expandProperties);
        try (final InputStreamReader inputStreamReader = new InputStreamReader(PolicyUtil.getInputStream(obj))) {
            policyParser.read(inputStreamReader);
            KeyStore initKeyStore = this.initKeyStore(obj, policyParser.getKeyStoreUrl(), policyParser.getKeyStoreType());
            Enumeration<PolicyParser.GrantEntry> grantElements = policyParser.grantElements();
            while (grantElements.hasMoreElements()) {
                this.addGrantEntry((PolicyParser.GrantEntry)grantElements.nextElement(), initKeyStore);
            }
        }
        catch (PolicyParser.ParsingException ex) {
            System.err.println("java.security.auth.policy" + AuthPolicyFile.rb.getString(".error.parsing.") + obj);
            System.err.println("java.security.auth.policy" + AuthPolicyFile.rb.getString("COLON") + ex.getMessage());
            if (AuthPolicyFile.debug != null) {
                ex.printStackTrace();
            }
        }
        catch (Exception ex2) {
            if (AuthPolicyFile.debug != null) {
                AuthPolicyFile.debug.println("error parsing " + obj);
                AuthPolicyFile.debug.println(ex2.toString());
                ex2.printStackTrace();
            }
        }
    }
    
    CodeSource getCodeSource(PolicyParser.GrantEntry grantEntry, KeyStore keyStore) throws MalformedURLException {
        Certificate[] certificates = null;
        if (grantEntry.signedBy != null) {
            certificates = this.getCertificates(keyStore, grantEntry.signedBy);
            if (certificates == null) {
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println(" no certs for alias " + grantEntry.signedBy + ", ignoring.");
                }
                return null;
            }
        }
        Object url;
        if (grantEntry.codeBase != null) {
            url = new URL(grantEntry.codeBase);
        }
        else {
            url = null;
        }
        if (grantEntry.principals == null || grantEntry.principals.size() == 0) {
            return this.canonicalizeCodebase(new CodeSource(url, certificates), false);
        }
        return this.canonicalizeCodebase(new SubjectCodeSource(null, grantEntry.principals, url, certificates), false);
    }
    
    private void addGrantEntry(PolicyParser.GrantEntry obj, KeyStore keyStore) {
        if (AuthPolicyFile.debug != null) {
            AuthPolicyFile.debug.println("Adding policy entry: ");
            AuthPolicyFile.debug.println("  signedBy " + obj.signedBy);
            AuthPolicyFile.debug.println("  codeBase " + obj.codeBase);
            if (obj.principals != null) {
                for (PolicyParser.PrincipalEntry principalEntry : obj.principals) {
                    AuthPolicyFile.debug.println("  " + principalEntry.getPrincipalClass() + " " + principalEntry.getPrincipalName());
                }
            }
            AuthPolicyFile.debug.println();
        }
        try {
            CodeSource codeSource = this.getCodeSource(obj, keyStore);
            if (codeSource == null) {
                return;
            }
            AuthPolicyFile.PolicyEntry obj2 = new PolicyEntry(codeSource);
            Enumeration<PolicyParser.PermissionEntry> permissionElements = obj.permissionElements();
            while (permissionElements.hasMoreElements()) {
                PolicyParser.PermissionEntry permissionEntry = (PolicyParser.PermissionEntry)permissionElements.nextElement();
                try {
                    Permission obj3;
                    if (permissionEntry.permission.equals("javax.security.auth.PrivateCredentialPermission") && permissionEntry.name.endsWith(" self")) {
                        obj3 = getInstance(permissionEntry.permission, permissionEntry.name + " \"self\"", permissionEntry.action);
                    }
                    else {
                        obj3 = getInstance(permissionEntry.permission, permissionEntry.name, permissionEntry.action);
                    }
                    obj2.add(obj3);
                    if (AuthPolicyFile.debug != null) {
                        AuthPolicyFile.debug.println("  " + obj3);
                    }
                    else {
                        continue;
                    }
                }
                catch (ClassNotFoundException ex) {
                    Certificate[] certificates;
                    if (permissionEntry.signedBy != null) {
                        certificates = this.getCertificates(keyStore, permissionEntry.signedBy);
                    }
                    else {
                        certificates = null;
                    }
                    if (certificates != null || permissionEntry.signedBy == null) {
                        UnresolvedPermission obj4 = new UnresolvedPermission(permissionEntry.permission, permissionEntry.name, permissionEntry.action, certificates);
                        obj2.add(obj4);
                        if (AuthPolicyFile.debug != null) {
                            AuthPolicyFile.debug.println("  " + obj4);
                        }
                        else {
                            continue;
                        }
                    }
                    else {
                        continue;
                    }
                }
                catch (InvocationTargetException ex2) {
                    System.err.println("java.security.auth.policy" + AuthPolicyFile.rb.getString(".error.adding.Permission.") + permissionEntry.permission + AuthPolicyFile.rb.getString("SPACE") + ex2.getTargetException());
                }
                catch (Exception obj5) {
                    System.err.println("java.security.auth.policy" + AuthPolicyFile.rb.getString(".error.adding.Permission.") + permissionEntry.permission + AuthPolicyFile.rb.getString("SPACE") + obj5);
                }
            }
            this.policyEntries.addElement(obj2);
        }
        catch (Exception obj6) {
            System.err.println("java.security.auth.policy" + AuthPolicyFile.rb.getString(".error.adding.Entry.") + obj + AuthPolicyFile.rb.getString("SPACE") + obj6);
        }
        if (AuthPolicyFile.debug != null) {
            AuthPolicyFile.debug.println();
        }
    }
    
    private static final Permission getInstance(String className, String s, String s2) throws ClassNotFoundException, InstantiationException, IllegalAccessException, NoSuchMethodException, InvocationTargetException {
        return (Permission)Class.forName(className).getConstructor(AuthPolicyFile.PARAMS).newInstance(new Object[] { s, s2 });
    }
    
    Certificate[] getCertificates(KeyStore keyStore, String str) {
        Object o = null;
        StringTokenizer stringTokenizer = new StringTokenizer(str, ",");
        int n = 0;
        while (stringTokenizer.hasMoreTokens()) {
            String trim = stringTokenizer.nextToken().trim();
            ++n;
            Certificate certificate = (Certificate)this.aliasMapping.get(trim);
            if (certificate == null && keyStore != null) {
                try {
                    certificate = keyStore.getCertificate(trim);
                }
                catch (KeyStoreException ex) {}
                if (certificate != null) {
                    this.aliasMapping.put(trim, certificate);
                    this.aliasMapping.put(certificate, trim);
                }
            }
            if (certificate != null) {
                if (o == null) {
                    o = new Vector();
                }
                o.addElement(certificate);
            }
            else {
                continue;
            }
        }
        if (o != null && n == o.size()) {
            Certificate[] anArray = new Certificate[o.size()];
            o.copyInto(anArray);
            return anArray;
        }
        return null;
    }
    
    private final synchronized Enumeration<AuthPolicyFile.PolicyEntry> elements() {
        return this.policyEntries.elements();
    }
    
    public PermissionCollection getPermissions(final Subject subject, final CodeSource codeSource) {
        return (PermissionCollection)AccessController.doPrivileged(new PrivilegedAction<PermissionCollection>() {
            @Override
            public PermissionCollection run() {
                SubjectCodeSource o = new SubjectCodeSource(subject, null, (codeSource == null) ? null : codeSource.getLocation(), (codeSource == null) ? null : codeSource.getCertificates());
                if (AuthPolicyFile.this.initialized) {
                    return AuthPolicyFile.this.getPermissions(new Permissions(), o);
                }
                return new PolicyPermissions(AuthPolicyFile.this, o);
            }
        });
    }
    
    PermissionCollection getPermissions(CodeSource codeSource) {
        if (this.initialized) {
            return this.getPermissions(new Permissions(), codeSource);
        }
        return new PolicyPermissions(this, codeSource);
    }
    
    Permissions getPermissions(Permissions permissions, CodeSource codeSource) {
        if (!this.initialized) {
            this.init();
        }
        CodeSource[] array = { null };
        array[0] = this.canonicalizeCodebase(codeSource, true);
        if (AuthPolicyFile.debug != null) {
            AuthPolicyFile.debug.println("evaluate(" + array[0] + ")\n");
        }
        for (int i = 0; i < this.policyEntries.size(); ++i) {
            AuthPolicyFile.PolicyEntry policyEntry = (AuthPolicyFile.PolicyEntry)this.policyEntries.elementAt(i);
            if (AuthPolicyFile.debug != null) {
                AuthPolicyFile.debug.println("PolicyFile CodeSource implies: " + policyEntry.codesource.toString() + "\n\n\t" + array[0].toString() + "\n\n");
            }
            if (policyEntry.codesource.implies(array[0])) {
                for (int j = 0; j < policyEntry.permissions.size(); ++j) {
                    Permission permission = (Permission)policyEntry.permissions.elementAt(j);
                    if (AuthPolicyFile.debug != null) {
                        AuthPolicyFile.debug.println("  granting " + permission);
                    }
                    if (!this.addSelfPermissions(permission, policyEntry.codesource, array[0], permissions)) {
                        permissions.add(permission);
                    }
                }
            }
        }
        if (!this.ignoreIdentityScope) {
            Certificate[] certificates = array[0].getCertificates();
            if (certificates != null) {
                for (int k = 0; k < certificates.length; ++k) {
                    if (this.aliasMapping.get(certificates[k]) == null && this.checkForTrustedIdentity(certificates[k])) {
                        permissions.add(new AllPermission());
                    }
                }
            }
        }
        return permissions;
    }
    
    private boolean addSelfPermissions(Permission permission, CodeSource codeSource, CodeSource codeSource2, Permissions permissions) {
        if (!(permission instanceof PrivateCredentialPermission)) {
            return false;
        }
        if (!(codeSource instanceof SubjectCodeSource)) {
            return false;
        }
        PrivateCredentialPermission privateCredentialPermission = (PrivateCredentialPermission)permission;
        SubjectCodeSource subjectCodeSource = (SubjectCodeSource)codeSource;
        String[][] principals = privateCredentialPermission.getPrincipals();
        if (principals.length <= 0 || !principals[0][0].equalsIgnoreCase("self") || !principals[0][1].equalsIgnoreCase("self")) {
            return false;
        }
        if (subjectCodeSource.getPrincipals() == null) {
            return true;
        }
        Iterator<Object> iterator = subjectCodeSource.getPrincipals().iterator();
        while (iterator.hasNext()) {
            String[][] principalInfo = this.getPrincipalInfo((PolicyParser.PrincipalEntry)iterator.next(), codeSource2);
            for (int i = 0; i < principalInfo.length; ++i) {
                PrivateCredentialPermission permission2 = new PrivateCredentialPermission(privateCredentialPermission.getCredentialClass() + " " + principalInfo[i][0] + " \"" + principalInfo[i][1] + "\"", "read");
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("adding SELF permission: " + permission2.toString());
                }
                permissions.add(permission2);
            }
        }
        return true;
    }
    
    private String[][] getPrincipalInfo(PolicyParser.PrincipalEntry principalEntry, CodeSource codeSource) {
        if (!principalEntry.getPrincipalClass().equals("WILDCARD_PRINCIPAL_CLASS") && !principalEntry.getPrincipalName().equals("WILDCARD_PRINCIPAL_NAME")) {
            String[][] array3 = new String[1][2];
            array3[0][0] = principalEntry.getPrincipalClass();
            array3[0][1] = principalEntry.getPrincipalName();
            return array3;
        }
        if (!principalEntry.getPrincipalClass().equals("WILDCARD_PRINCIPAL_CLASS") && principalEntry.getPrincipalName().equals("WILDCARD_PRINCIPAL_NAME")) {
            SubjectCodeSource subjectCodeSource = (SubjectCodeSource)codeSource;
            Set<Principal> principals2 = null;
            try {
                principals2 = subjectCodeSource.getSubject().getPrincipals(Class.forName(principalEntry.getPrincipalClass(), false, ClassLoader.getSystemClassLoader()));
            }
            catch (Exception ex) {
                if (AuthPolicyFile.debug != null) {
                    AuthPolicyFile.debug.println("problem finding Principal Class when expanding SELF permission: " + ex.toString());
                }
            }
            if (principals2 == null) {
                return new String[0][0];
            }
            String[][] array2 = new String[principals2.size()][2];
            int n2 = 0;
            for (Principal principal2 : principals2) {
                array2[n2][0] = principal2.getClass().getName();
                array2[n2][1] = principal2.getName();
                ++n2;
            }
            return array2;
        }
        else {
            Set<Principal> principals = ((SubjectCodeSource)codeSource).getSubject().getPrincipals();
            String[][] array = new String[principals.size()][2];
            int n = 0;
            for (Principal principal : principals) {
                array[n][0] = principal.getClass().getName();
                array[n][1] = principal.getName();
                ++n;
            }
            return array;
        }
    }
    
    Certificate[] getSignerCertificates(CodeSource codeSource) {
        Certificate[] certificates;
        if ((certificates = codeSource.getCertificates()) == null) {
            return null;
        }
        int i = 0;
        while (i < certificates.length) {
            if (!(certificates[i] instanceof X509Certificate)) {
                return codeSource.getCertificates();
            }
            ++i;
        }
        int j = 0;
        int n = 0;
        while (j < certificates.length) {
            ++n;
            while (j + 1 < certificates.length && ((X509Certificate)certificates[j]).getIssuerDN().equals(((X509Certificate)certificates[j + 1]).getSubjectDN())) {
                ++j;
            }
            ++j;
        }
        if (n == certificates.length) {
            return certificates;
        }
        ArrayList<Object> list = new ArrayList();
        for (int k = 0; k < certificates.length; ++k) {
            list.add(certificates[k]);
            while (k + 1 < certificates.length && ((X509Certificate)certificates[k]).getIssuerDN().equals(((X509Certificate)certificates[k + 1]).getSubjectDN())) {
                ++k;
            }
        }
        Certificate[] a = new Certificate[list.size()];
        list.toArray(a);
        return a;
    }
    
    private CodeSource canonicalizeCodebase(CodeSource o, boolean b) {
        if (o.getLocation() != null && o.getLocation().getProtocol().equalsIgnoreCase("file")) {
            try {
                String replace = o.getLocation().getFile().replace('/', File.separatorChar);
                String pathname;
                if (replace.endsWith("*")) {
                    String pathname2 = replace.substring(0, replace.length() - 1);
                    boolean n = false;
                    if (pathname2.endsWith(File.separator)) {
                        n = true;
                    }
                    if (pathname2.equals("")) {
                        pathname2 = System.getProperty("user.dir");
                    }
                    File o2 = new File(pathname2);
                    String canonicalPath = o2.getCanonicalPath();
                    StringBuffer o3 = new StringBuffer(canonicalPath);
                    if (!canonicalPath.endsWith(File.separator) && (n || o2.isDirectory())) {
                        o3.append(File.separatorChar);
                    }
                    o3.append('*');
                    pathname = o3.toString();
                }
                else {
                    pathname = new File(replace).getCanonicalPath();
                }
                URL url = new File(pathname).toURL();
                if ((o instanceof SubjectCodeSource)) {
                    SubjectCodeSource subjectCodeSource2 = (SubjectCodeSource)o;
                    if (b) {
                        o = new SubjectCodeSource(subjectCodeSource2.getSubject(), subjectCodeSource2.getPrincipals(), url, this.getSignerCertificates(subjectCodeSource2));
                    }
                    else {
                        o = new SubjectCodeSource(subjectCodeSource2.getSubject(), subjectCodeSource2.getPrincipals(), url, subjectCodeSource2.getCertificates());
                    }
                }
                else if (b) {
                    o = new CodeSource(url, this.getSignerCertificates(o));
                }
                else {
                    o = new CodeSource(url, o.getCertificates());
                }
            }
            catch (IOException ex) {
                if (b) {
                    if (!(o instanceof SubjectCodeSource)) {
                        o = new CodeSource(o.getLocation(), this.getSignerCertificates(o));
                    }
                    else {
                        SubjectCodeSource subjectCodeSource3 = (SubjectCodeSource)o;
                        o = new SubjectCodeSource(subjectCodeSource3.getSubject(), subjectCodeSource3.getPrincipals(), subjectCodeSource3.getLocation(), this.getSignerCertificates(subjectCodeSource3));
                    }
                }
            }
        }
        else if (b) {
            if (!(o instanceof SubjectCodeSource)) {
                o = new CodeSource(o.getLocation(), this.getSignerCertificates(o));
            }
            else {
                SubjectCodeSource subjectCodeSource = (SubjectCodeSource)o;
                o = new SubjectCodeSource(subjectCodeSource.getSubject(), subjectCodeSource.getPrincipals(), subjectCodeSource.getLocation(), this.getSignerCertificates(subjectCodeSource));
            }
        }
        return o;
    }
    
    static void access$000(AuthPolicyFile authPolicyFile) {
        authPolicyFile.init();
    }
    
    static {
        rb = (ResourceBundle)AccessController.doPrivileged(new PrivilegedAction<ResourceBundle>() {
            @Override
            public ResourceBundle run() {
                return ResourceBundle.getBundle("sun.security.util.AuthResources");
            }
        });
        debug = Debug.getInstance("policy", "\t[Auth Policy]");
        PARAMS = new Class[] { String.class, String.class };
    }
    
    private static class PolicyEntry
    {
        CodeSource codesource;
        Vector<Permission> permissions;
        
        PolicyEntry(CodeSource codesource) {
            this.codesource = codesource;
            this.permissions = new Vector();
        }
        
        void add(Permission obj) {
            this.permissions.addElement(obj);
        }
        
        CodeSource getCodeSource() {
            return this.codesource;
        }
        
        @Override
        public String toString() {
            StringBuffer sb = new StringBuffer();
            sb.append(AuthPolicyFile.rb.getString("LPARAM"));
            sb.append(this.getCodeSource());
            sb.append("\n");
            for (int i = 0; i < this.permissions.size(); ++i) {
                Permission obj = (Permission)this.permissions.elementAt(i);
                sb.append(AuthPolicyFile.rb.getString("SPACE"));
                sb.append(AuthPolicyFile.rb.getString("SPACE"));
                sb.append(obj);
                sb.append(AuthPolicyFile.rb.getString("NEWLINE"));
            }
            sb.append(AuthPolicyFile.rb.getString("RPARAM"));
            sb.append(AuthPolicyFile.rb.getString("NEWLINE"));
            return sb.toString();
        }
    }
}
